package	jp.co.sds_corp.syslog;

import java.util.EventObject;

import jp.co.sds_corp.util.syslog.SyslogMsg;

/**
* データが受信されたことを示すイベントです。
*/
public class SyslogEvent extends EventObject
{
	private static final long serialVersionUID = 1L;
	private SyslogMsg	msg;

	/**
	* SyslogEventを生成します。
	* @param	source		イベントの発生元
	* @param	msg			受信したデータ
	*/
	public SyslogEvent( Object source, SyslogMsg msg )
	{
		super( source );
		this.msg = msg;
	}

	/**
	* 受信したデータを返します。
	* @return	受信したデータ
	*/
	public SyslogMsg getMessage() {
		return msg;
	}

	/**
	* このイベントの文字列表現を返します。
	* @return	このイベントの文字列表現
	*/
	public String toString() {
		String	ret;
		ret = super.toString();
		ret += ":" + msg.toString();
		return ret;
	}
}
