package	jp.co.sds_corp.syslog.viewer.action;

import jp.co.sds_corp.syslog.action.IAction;

/**
* {@link IAction}の各種設定をするPanelのためのインターフェースです。
* @author	小見山　聡
*/
public interface IActionPanel
{
	/**
	* {@link IAction}を設定します。
	*/
	public void setAction( IAction action );
	/**
	* {@link IAction}を取得します。
	*/
	public IAction getAction();

	/**
	* 現在の{@link IAction}を入力された内容で設定します。
	*/
	public void updateAction() throws Exception;

	/**
	* 設定内容をクリアします。
	*/
	public void clear();

	/**
	* このパネルが有効かどうかを設定します。
	* @param	bChk	有効にする場合true　無効にする場合false
	*/
	public void setEnabled( boolean bChk );
}
