package jp.co.sds_corp.syslog.viewer.action;

import java.util.ResourceBundle;
import java.util.Vector;

import javax.swing.BoxLayout;
import javax.swing.border.TitledBorder;

import jp.co.sds_corp.syslog.action.IAction;
import jp.co.sds_corp.syslog.action.MailAction;
import jp.co.sds_corp.util.window.ValuePanel;

/**
* Mail送信に関する設定をするPanelです。
* @author	小見山　聡
*/
public class MailPanel extends AbstractPanel
{
	private static final long serialVersionUID = 1L;
	ValuePanel	VAL1;
	ValuePanel	VAL2;
	ValuePanel	VAL3;
	ValuePanel	VAL4;
	ValuePanel	VAL5;
	ValuePanel	VAL6;
	ResourceBundle res;

	/**
	* このパネルを初期化します。
	*/
	public MailPanel() {
		res = ResourceBundle.getBundle( "resource.viewer" );
		String text;
		text = res.getString( "action.mail.title" );
		setBorder( new TitledBorder( text ));
		setLayout( new BoxLayout( this, BoxLayout.Y_AXIS ));

		createControls();
	}

	protected void createControls() {
		String text;
		text = res.getString( "action.mail.lbl1.text" );
		VAL1 = new ValuePanel( ValuePanel.ReturnType.STRING, text );
		text = res.getString( "action.mail.lbl2.text" );
		VAL2 = new ValuePanel( ValuePanel.ReturnType.STRING, text );
		text = res.getString( "action.mail.lbl3.text" );
		VAL3 = new ValuePanel( ValuePanel.ReturnType.STRING, text );
		text = res.getString( "action.mail.lbl4.text" );
		VAL4 = new ValuePanel( ValuePanel.ReturnType.STRING, text );
		text = res.getString( "action.mail.lbl5.text" );
		VAL5 = new ValuePanel( ValuePanel.ReturnType.STRING, text );
		text = res.getString( "action.mail.lbl6.text" );
		VAL6 = new ValuePanel( ValuePanel.ReturnType.STRING, text );
		add( VAL1 );
		add( VAL2 );
		add( VAL3 );
		add( VAL4 );
		add( VAL5 );
		add( VAL6 );
	}

	public void setEnabled( boolean bEn ) {
		super.setEnabled( bEn );
		VAL1.setEnabled( bEn );
		VAL2.setEnabled( bEn );
		VAL3.setEnabled( bEn );
		VAL4.setEnabled( bEn );
		VAL5.setEnabled( bEn );
		VAL6.setEnabled( bEn );
	}

	public void clear() {
		VAL1.setValue( null );
		VAL2.setValue( null );
		VAL3.setValue( null );
		VAL4.setValue( null );
		VAL5.setValue( null );
		VAL6.setValue( null );
	}

	public void setAction( IAction action ) {
		super.setAction( action );
		if ( action == null ) {
			clear();
			return;
		}
		MailAction ma = (MailAction )action;
		VAL1.setValue( ma.getServer() );
		VAL2.setValue( ma.getFrom() );
		VAL3.setValue( addressString( ma.getTo() ));
		VAL4.setValue( addressString( ma.getCc() ));
		VAL5.setValue( addressString( ma.getBcc() ));
		VAL6.setValue( ma.getSubject() );
	}

	private String addressString( Vector<String> vec ) {
		StringBuilder buf = new StringBuilder();
		for ( int i = 0; i < vec.size(); i++ ) {
			if ( i > 0 ) {
				buf.append( ";" );
			}
			buf.append( vec.get( i ));
		}
		return buf.toString();
	}

	public void updateAction() throws Exception {
		String var;
		var = (String )VAL1.getValue();
		if ( var == null || var.length() == 0 ) {
			String msg = res.getString( "action.mail.err1.message" );
			throw( new Exception( msg ));
		}
		var = (String )VAL2.getValue();
		if ( var == null || var.length() == 0 ) {
			String msg = res.getString( "action.mail.err2.message" );
			throw( new Exception( msg ));
		}
		var = (String )VAL3.getValue();
		if ( var == null || var.length() == 0 ) {
			String msg = res.getString( "action.mail.err3.message" );
			throw( new Exception( msg ));
		}
		MailAction ma = (MailAction )action;
		ma.setServer( (String )VAL1.getValue() );
		ma.setFrom( (String )VAL2.getValue() );
		setAddress( ma.getTo(), (String )VAL3.getValue() );
		setAddress( ma.getCc(), (String )VAL4.getValue() );
		setAddress( ma.getBcc(), (String )VAL5.getValue() );
		ma.setSubject( (String )VAL6.getValue() );
	}

	private void setAddress( Vector<String> vec, String inp ) {
		String[] arr = inp.split( "[,;]" );
		vec.clear();
		for ( int i = 0; i < arr.length; i++ ) {
			if ( arr[i].length() > 0 ) {
				vec.add( arr[i] );
			}
		}
	}
}

